"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RequestContextImpl = /** @class */ (function () {
    function RequestContextImpl() {
        /**
         * 根路径
         */
        this.baseURL = null;
        /**
         * 全局的参数
         */
        this.globalParams = null;
        /**
         * 请求头部
         */
        this.requestHeaders = null;
        /**
         * 全局超时时间
         */
        this.timeout = 30000;
    }
    /**
     * 请求之前用
     */
    RequestContextImpl.prototype.beforeRequest = function (requestParams) {
    };
    /**
     * 请求成功之后
     * @param response
     */
    RequestContextImpl.prototype.afterRequest = function (response) {
    };
    /**
     * 请求失败之后
     */
    RequestContextImpl.prototype.requestFail = function (xhr) {
    };
    /**
     * 设置baseURL
     * @param baseURL
     */
    RequestContextImpl.prototype.setBaseURL = function (baseURL) {
        this.baseURL = baseURL;
    };
    /**
     * 获取baseURL
     */
    RequestContextImpl.prototype.getBaseURL = function () {
        return this.baseURL;
    };
    /**
     * 设置全局请求参数
     */
    RequestContextImpl.prototype.setGlobalParams = function (params) {
        this.globalParams = params;
    };
    /**
     * 获取全局参数
     */
    RequestContextImpl.prototype.getGlobalParams = function () {
        return this.globalParams;
    };
    /**
     * 设置请求头部
     */
    RequestContextImpl.prototype.setRequestHeaders = function (header) {
        if (this.requestHeaders === null)
            this.requestHeaders = {};
        Object.assign(this["requestHeaders"], header);
    };
    /**
     * 获取请求头部信息
     */
    RequestContextImpl.prototype.getRequestHeaders = function () {
        if (this.requestHeaders === null)
            return {};
        return this.requestHeaders;
    };
    /**
     * 设置超时时间
     */
    RequestContextImpl.prototype.setTimeout = function (timeout) {
        this.timeout = timeout;
    };
    /**
     * 获取超时时间
     */
    RequestContextImpl.prototype.getTimeout = function () {
        return this.timeout;
    };
    /**
     * 监听超时事件
     */
    RequestContextImpl.prototype.onTimeout = function () {
    };
    /**
     * 请求出错
     */
    RequestContextImpl.prototype.onError = function () { };
    /**
     * 上传的实时进度
     */
    RequestContextImpl.prototype.onprogress = function (params) {
    };
    return RequestContextImpl;
}());
exports.requestContext = new RequestContextImpl();
