"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_1 = __importDefault(require("vue"));
var vuex_1 = __importDefault(require("vuex"));
var vuex_2 = require("./vuex");
vue_1.default.use(vuex_1.default);
var Service = /** @class */ (function () {
    function Service(vuexStoreConfig) {
        if (vuexStoreConfig === void 0) { vuexStoreConfig = {}; }
        this.vuexStoreConfig = vuexStoreConfig || {};
    }
    Service.prototype.registerModule = function (VuexModule) {
        if (!this.vuexStoreConfig.modules)
            this.vuexStoreConfig.modules = {};
        if (typeof VuexModule === 'function') {
            var vuexModule = new VuexModule();
            //判断是否继承了 VuexModuleClass
            if (vuexModule instanceof vuex_2.VuexModuleClass) {
                Object.assign(this.vuexStoreConfig.modules, vuexModule);
            }
            else {
                var errMsg = "Error registering module: module must inherit VuexModuleClass or decorate with @VuexModule";
                throw new Error(errMsg);
            }
        }
        else {
            Object.assign(this.vuexStoreConfig.modules, VuexModule);
        }
    };
    Service.prototype.createStore = function () {
        return new vuex_1.default.Store(this.vuexStoreConfig);
    };
    return Service;
}());
exports.Service = Service;
