"use strict";
/**
 * 一个VuexModule模块 可以直接继承此类 也可以使用 @VuexModule 装饰器来构造一个vuex的模块
 */
Object.defineProperty(exports, "__esModule", { value: true });
var VuexModuleClass = /** @class */ (function () {
    function VuexModuleClass(name, namespace, strict) {
        if (name === void 0) { name = null; }
        if (namespace === void 0) { namespace = true; }
        if (strict === void 0) { strict = true; }
        this._name = name;
        this._namespace = namespace;
        this._strict = strict;
    }
    VuexModuleClass.prototype.generate = function (target) {
        var keys = Object.getOwnPropertyNames(target.__proto__).slice(1);
        var state = {};
        var mutations = {};
        var actions = {};
        var getters = {};
        var stateKeys = Object.getOwnPropertyNames(target);
        stateKeys.forEach(function (key) {
            if (key !== '_name' && key !== '_namespace' && key !== "_strict")
                state[key] = target[key];
        });
        keys.forEach(function (key) {
            var type = target.__proto__[key].VUEX_MODULE_TYPE;
            switch (type) {
                case "actions":
                    actions[key] = target.__proto__[key].bind(mutations);
                    break;
                case "mutations":
                    mutations[key] = target.__proto__[key].bind(state);
                    break;
                case "getters":
                    getters[key] = target.__proto__[key];
            }
        });
        var moduleName = this._name || target.__proto__.constructor.name;
        target[moduleName] = {
            actions: actions,
            mutations: mutations,
            state: state,
            namespace: this._namespace,
            strict: this._strict
        };
        stateKeys.forEach(function (key) { return delete target[key]; });
    };
    return VuexModuleClass;
}());
exports.VuexModuleClass = VuexModuleClass;
